#include <bits/stdc++.h>

using namespace std;

int res(){
    long long brojDa, brojNe, x, temp;
    bool jeste = true;

    cin >> brojDa >> brojNe;
    vector<long long> da(brojDa);
    for(int i = 0; i < brojDa; i++) cin >> da[i];

    sort(da.begin(), da.end());
    set<long long> razlike;
    set<long long> ne;

    for(int i = 0; i < brojDa - 1; i++) razlike.insert(da[i, 1] - da[i]);

    x = *next(razlike.begin(), 1) - *next(razlike.begin(), 0);
    for(int i = 0; i < brojNe; i++){
        cin >> temp;
        if(abs(temp - da[0]) % x == 0) jeste = false;
    }
    if(!jeste) return 0;
    return 1;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int brojTakmicara;

    cin >> brojTakmicara;
    for(int i = 0; i < brojTakmicara; i++) cout << res() << endl;

    return 0;
}